#pragma once

#include "Watchy.h"
#include "Menu.h"
#include "WatchFacePages/Clock.h"
#include "WatchFacePages/Weather.h"
#include <memory>

class WatchFace : public Watchy
{
public:
  void InitBoot() override; // Called once when the watch starts up
  void InitWake() override; // Called every time the watch wakes from sleep
  void HandleButtonPress(uint64_t buttonMask) override;
  void HandleDoubleTap() override;
  void HandleTilt() override;
  void DrawWatchFace(bool partialRefresh = false) override;

private:
  RTC_DATA_ATTR static bool m_inMenu;
  RTC_DATA_ATTR static Menu m_menu;
  RTC_DATA_ATTR static uint8_t m_watchFacePage;
  std::vector<std::shared_ptr<WatchFacePages::Page>> m_pages = {
    std::make_shared<WatchFacePages::Clock>(m_display, m_features),
    std::make_shared<WatchFacePages::Weather>(m_display, m_features)
  };

  void SetupVolatileMenuStuff();
  void DrawBatteryIcon();
  void MenuExited();
  void MenuNTPSyncSelected();
  void MenuTimeZoneSelected(int tzOffset);
  void MenuConfirmResetSteps();
};