#include "../config.h"
#include "Storage.h"
#include <EEPROM.h>

WatchFeatures::Storage::Storage()
{

}

void WatchFeatures::Storage::InitBoot()
{
  EEPROM.begin(512);
  if (EEPROM.read(EEPROM_LOCATION_MAGIC) != EEPROM_MAGIC1
      || EEPROM.read(EEPROM_LOCATION_MAGIC + 1) != EEPROM_MAGIC2)
  {
    Serial.println("Initializing EEPROM");
    EEPROM.write(EEPROM_LOCATION_MAGIC, EEPROM_MAGIC1);
    EEPROM.write(EEPROM_LOCATION_MAGIC + 1, EEPROM_MAGIC2);
    uint16_t version = EEPROM_VERSION;
    EEPROM.write(EEPROM_LOCATION_VERSION, version & 0xFF);
    EEPROM.write(EEPROM_LOCATION_VERSION + 1, version >> 8);

    int offset = DEFAULT_TZ_OFFSET;
    EEPROM.write(EEPROM_LOCATION_TZ_OFFSET, offset & 0xFF);
    EEPROM.write(EEPROM_LOCATION_TZ_OFFSET + 1, (offset >> 8) & 0xFF);
    EEPROM.write(EEPROM_LOCATION_TZ_OFFSET + 2, (offset >> 16) & 0xFF);
    EEPROM.write(EEPROM_LOCATION_TZ_OFFSET + 3, (offset >> 24) & 0xFF);
    EEPROM.commit();
  }

  uint16_t version = EEPROM.read(EEPROM_LOCATION_VERSION) | (EEPROM.read(EEPROM_LOCATION_VERSION + 1) << 8);
  if (version != EEPROM_VERSION)
  {
    // TODO: Handle version mismatch
  }
}

void WatchFeatures::Storage::InitWake()
{
  EEPROM.begin(512);
}

int32_t WatchFeatures::Storage::GetTzOffset()
{
  return EEPROM.read(EEPROM_LOCATION_TZ_OFFSET)
    | (EEPROM.read(EEPROM_LOCATION_TZ_OFFSET + 1) << 8)
    | (EEPROM.read(EEPROM_LOCATION_TZ_OFFSET + 2) << 16)
    | (EEPROM.read(EEPROM_LOCATION_TZ_OFFSET + 3) << 24);
}

void WatchFeatures::Storage::SetTzOffset(int offset)
{
  EEPROM.write(EEPROM_LOCATION_TZ_OFFSET, offset & 0xFF);
  EEPROM.write(EEPROM_LOCATION_TZ_OFFSET + 1, (offset >> 8) & 0xFF);
  EEPROM.write(EEPROM_LOCATION_TZ_OFFSET + 2, (offset >> 16) & 0xFF);
  EEPROM.write(EEPROM_LOCATION_TZ_OFFSET + 3, (offset >> 24) & 0xFF);
  EEPROM.commit();
}